#ifndef _population_h
#define _population_h

#include <iostream>
#include <vector>
#include <algorithm>
#include <solution.h>

/**
   Classe pour représenter une population
   
*/
class Population : public std::vector<Solution> {
public:
  Population() : std::vector<Solution>() {
  }

  Population(const Population & _pop) : std::vector<Solution>(_pop) {
  }

  Solution & bestSolution() {
    Solution * best = & ((*this)[0]);
    for(int i = 1; i < this->size(); i++)
      if (best->fitness() < (*this)[i].fitness())
	best = & ((*this)[i]);
    
    return *best;
  }

  void print() {
    std::cout << size() << ' ';
    std::cout << std::endl;
    for(int i = 0; i < size(); i++) {
      (*this)[i].print();
      std::cout << std::endl;
    }
  }

  struct Cmp
  {
    bool operator()(const Solution & a, const Solution & b) const
    {
      return b.fitness() < a.fitness();
    }
  };

  /**
   *  Sort the population. 
   *  Use this member to sort in order of descending fitness. 
   *  The first individual is the best!
  */
  void sort() {
    std::sort(begin(), end(), Cmp());
  }

};

#endif
